package com.sun.corba.se.impl.encoding;

import com.sun.org.omg.SendingContext.CodeBaseHelper;
import com.sun.org.omg.CORBA.ValueDefPackage.FullValueDescription;
import com.sun.org.omg.CORBA.Repository;
import java.util.Iterator;
import com.sun.corba.se.spi.orb.ORB;
import com.sun.corba.se.spi.ior.IOR;
import com.sun.corba.se.spi.transport.CorbaConnection;
import com.sun.org.omg.SendingContext.CodeBase;
import java.util.Hashtable;
import com.sun.org.omg.SendingContext._CodeBaseImplBase;

public class CachedCodeBase extends _CodeBaseImplBase
{
    private Hashtable implementations;
    private Hashtable fvds;
    private Hashtable bases;
    private volatile CodeBase delegate;
    private CorbaConnection conn;
    private static Object iorMapLock;
    private static Hashtable<IOR, CodeBase> iorMap;
    
    public static synchronized void cleanCache(ORB orb) {
        synchronized (CachedCodeBase.iorMapLock) {
            for (IOR key : CachedCodeBase.iorMap.keySet()) {
                if (key.getORB() == orb) {
                    CachedCodeBase.iorMap.remove(key);
                }
                else {
                    continue;
                }
            }
        }
    }
    
    public CachedCodeBase(CorbaConnection conn) {
        this.conn = conn;
    }
    
    public Repository get_ir() {
        return null;
    }
    
    public synchronized String implementation(String s) {
        String implementation = null;
        if (this.implementations == null) {
            this.implementations = new Hashtable();
        }
        else {
            implementation = (String)this.implementations.get(s);
        }
        if (implementation == null && this.connectedCodeBase()) {
            implementation = this.delegate.implementation(s);
            if (implementation != null) {
                this.implementations.put(s, implementation);
            }
        }
        return implementation;
    }
    
    public synchronized String[] implementations(String[] array) {
        String[] array2 = new String[array.length];
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = this.implementation(array[i]);
        }
        return array2;
    }
    
    public synchronized FullValueDescription meta(String s) {
        FullValueDescription meta = null;
        if (this.fvds == null) {
            this.fvds = new Hashtable();
        }
        else {
            meta = (FullValueDescription)this.fvds.get(s);
        }
        if (meta == null && this.connectedCodeBase()) {
            meta = this.delegate.meta(s);
            if (meta != null) {
                this.fvds.put(s, meta);
            }
        }
        return meta;
    }
    
    public synchronized FullValueDescription[] metas(String[] array) {
        FullValueDescription[] array2 = new FullValueDescription[array.length];
        for (int i = 0; i < array2.length; ++i) {
            array2[i] = this.meta(array[i]);
        }
        return array2;
    }
    
    public synchronized String[] bases(String s) {
        String[] bases = null;
        if (this.bases == null) {
            this.bases = new Hashtable();
        }
        else {
            bases = (String[])(String[])this.bases.get(s);
        }
        if (bases == null && this.connectedCodeBase()) {
            bases = this.delegate.bases(s);
            if (bases != null) {
                this.bases.put(s, bases);
            }
        }
        return bases;
    }
    
    private synchronized boolean connectedCodeBase() {
        if (this.delegate != null) {
            return true;
        }
        if (this.conn.getCodeBaseIOR() == null) {
            if (this.conn.getBroker().transportDebugFlag) {
                this.conn.dprint("CodeBase unavailable on connection: " + this.conn);
            }
            return false;
        }
        else {
            synchronized (CachedCodeBase.iorMapLock) {
                if (this.delegate != null) {
                    return true;
                }
                this.delegate = (CodeBase)CachedCodeBase.iorMap.get(this.conn.getCodeBaseIOR());
                if (this.delegate != null) {
                    return true;
                }
                this.delegate = CodeBaseHelper.narrow(this.getObjectFromIOR());
                CachedCodeBase.iorMap.put(this.conn.getCodeBaseIOR(), this.delegate);
            }
            return true;
        }
    }
    
    private final org.omg.CORBA.Object getObjectFromIOR() {
        return CDRInputStream_1_0.internalIORToObject(this.conn.getCodeBaseIOR(), null, this.conn.getBroker());
    }
    
    static {
        CachedCodeBase.iorMapLock = new Object();
        CachedCodeBase.iorMap = new Hashtable();
    }
}
